package nianioTest.nianio.types;

import nianio.AppLogicExtCmd;
import nianio.AppLogicExtCmds;
import ocean.common.Err;

public class AppLogicExtCmdAcc {
	private AppLogicExtCmds resOrNull = AppLogicExtCmds.EMPTY;

	private class MyMM implements AppLogicExtCmd.MM {
		public void invoke(AppLogicExtCmd cmd) {
			doInvoke(cmd);
		}
	}

	public AppLogicExtCmd.MMIntf getMMIntf() {
		return AppLogicExtCmd.MMConv.asIntf(new MyMM());
	}

	public AppLogicExtCmd.MM getMM() {
		return new MyMM();
	}

	public AppLogicExtCmds getResult() {
		AppLogicExtCmds res = resOrNull;
		resOrNull = null;
		Err.ensure(res != null);
		return res;
	}

	private void doInvoke(AppLogicExtCmd cmd) {
		AppLogicExtCmds res = resOrNull;
		Err.ensure(res != null);
		res = res.add(cmd);
		resOrNull = res;
	}
}
